<'
'>
o demonstrate the generation of random fp numbers between 0 to 1
	this demo will generate three lists of fp numbers
		list 1: fp numbers >= 0 and <= 1
		list 2: fp numbers >= 0 and <  1
		list 3: fp numbers >  0 and <  1
	cnt controls how many fp numbers will be generated
o to run:
	snfp -p "load ex_rand_fp_gen_0_to_1; test"

<'
--import vrst_snfp/e/vrst_snfp_h ;


extend snfp_rnd_fp_s {
	keep kind == ZERO_TO_ONE;
};

extend sys {
	cnt : uint [20..50];			// how many to generate
	
		// numbers in: 0 <= rfp <= 1 
	rfpl1 : list of snfp_rnd_fp_s;	
		keep rfpl1.size() == cnt;
		// numbers in: 0 <= rfp <  1 
	rfpl2 : list of no_ones snfp_rnd_fp_s;	
		keep rfpl2.size() == cnt;
		// numbers in: 0 <  rfp <  1 
	rfpl3 : list of no_zeros no_ones snfp_rnd_fp_s;	
		keep rfpl3.size() == cnt;
	//
	post_generate() is also {
		out("print random fp in: [0..1]");
		for each (rfp) in rfpl1 {
			out("random fp(", index,") = ", rfp.str_rep);
		};
		out("print random fp in: [0..1)");
		for each (rfp) in rfpl2 {
			out("random fp(", index,") = ", rfp.str_rep);
		};
		out("print random fp in: (0..1)");
		for each (rfp) in rfpl3 {
			out("random fp(", index,") = ", rfp.str_rep);
		};
	};
	init() is also {
		set_config(run, use_manual_tick, TRUE);
	};
};

'>
------------------------
-----  CODE END   ------
------------------------
